/* application-window.c generated by valac 0.46.6, the Vala compiler
 * generated from application-window.vala, do not modify */

/*
Peek Copyright (c) 2015-2017 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.

This file contains GPL 3 code taken from corebird, a Gtk+ linux Twitter client.
Copyright (C) 2013 Timm Bäder, https://github.com/baedert/corebird/
*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include "application.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <stdio.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#define PEEK_UI_TYPE_APPLICATION_WINDOW (peek_ui_application_window_get_type ())
#define PEEK_UI_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow))
#define PEEK_UI_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))
#define PEEK_UI_IS_APPLICATION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_IS_APPLICATION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PEEK_UI_TYPE_APPLICATION_WINDOW))
#define PEEK_UI_APPLICATION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindowClass))

typedef struct _PeekUiApplicationWindow PeekUiApplicationWindow;
typedef struct _PeekUiApplicationWindowClass PeekUiApplicationWindowClass;
typedef struct _PeekUiApplicationWindowPrivate PeekUiApplicationWindowPrivate;
enum  {
	PEEK_UI_APPLICATION_WINDOW_0_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY,
	PEEK_UI_APPLICATION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))
typedef struct _Block6Data Block6Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
enum  {
	PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL,
	PEEK_UI_APPLICATION_WINDOW_NUM_SIGNALS
};
static guint peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_NUM_SIGNALS] = {0};

struct _PeekUiApplicationWindow {
	GtkApplicationWindow parent_instance;
	PeekUiApplicationWindowPrivate * priv;
};

struct _PeekUiApplicationWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _PeekUiApplicationWindowPrivate {
	PeekRecordingScreenRecorder* _recorder;
	gboolean _open_file_manager;
	gint _size_indicator_delay;
	gint _recording_start_delay;
	gchar* _default_file_name_format;
	gchar* _save_folder;
	GtkHeaderBar* headerbar;
	GtkWidget* recording_view;
	GtkButton* record_button;
	GtkButton* stop_button;
	GtkLabel* size_indicator;
	GtkLabel* delay_indicator;
	guint size_indicator_timeout;
	guint delay_indicator_timeout;
	gboolean screen_supports_alpha;
	gboolean is_recording;
	gboolean is_postprocessing;
	GFile* in_file;
	GFile* out_file;
	PeekRecordingRecordingArea active_recording_area;
	gchar* stop_button_label;
	GSettings* settings;
};

struct _Block4Data {
	int _ref_count_;
	PeekUiApplicationWindow* self;
	gint delay;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	gulong hide_handler;
};

struct _Block6Data {
	int _ref_count_;
	PeekUiApplicationWindow* self;
	GtkWidget* fallback_app_menu;
};

static gint PeekUiApplicationWindow_private_offset;
static gpointer peek_ui_application_window_parent_class = NULL;

GType peek_ui_application_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PeekUiApplicationWindow, g_object_unref)
#define PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE 300
PeekUiApplicationWindow* peek_ui_application_window_new (PeekApplication* application,
                                                         PeekRecordingScreenRecorder* recorder);
PeekUiApplicationWindow* peek_ui_application_window_construct (GType object_type,
                                                               PeekApplication* application,
                                                               PeekRecordingScreenRecorder* recorder);
void peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self,
                                              PeekRecordingScreenRecorder* value);
PeekRecordingScreenRecorder* peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self);
static void __lambda7_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self);
static void ___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender,
                                                                   gpointer self);
static void __lambda8_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self);
static void ___lambda8__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender,
                                                                               gpointer self);
static void __lambda11_ (PeekUiApplicationWindow* self,
                  GFile* file);
static void peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self);
static void ___lambda11__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender,
                                                                     GFile* file,
                                                                     gpointer self);
static void __lambda12_ (PeekUiApplicationWindow* self,
                  gint status);
static void peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self);
static void ___lambda12__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender,
                                                                    gint status,
                                                                    gpointer self);
static void peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender,
                                                                                     gpointer self);
static void peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender,
                                                                                           gpointer self);
static void peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender,
                                                                                         gpointer self);
static void peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self);
void peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self,
                                                          GdkScreen* previous_screen);
static void __lambda15_ (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self);
static void ___lambda15__gtk_widget_show (GtkWidget* _sender,
                                   gpointer self);
static void peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self);
static gboolean peek_ui_application_window_real_configure_event (GtkWidget* base,
                                                          GdkEventConfigure* event);
static void peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self,
                                                    PeekRecordingRecordingArea* result);
static gboolean peek_ui_application_window_real_delete_event (GtkWidget* base,
                                                       GdkEventAny* event);
static void ___lambda17_ (PeekUiApplicationWindow* self,
                   PeekUiApplicationWindow* file);
static void ____lambda17__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender,
                                                                  gpointer self);
static void peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self);
static void _peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender,
                                                                                     GdkScreen* previous_screen,
                                                                                     gpointer self);
static gboolean peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self,
                                                            GtkWidget* widget,
                                                            cairo_t* ctx);
static void peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self);
static gboolean _peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                             cairo_t* cr,
                                                                             gpointer self);
static void peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self,
                                                                 GtkAllocation* allocation);
static void _peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                           GtkAllocation* allocation,
                                                                                           gpointer self);
static gint peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self);
gint peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self);
static gboolean _____lambda16_ (PeekUiApplicationWindow* self);
static gboolean ______lambda16__gsource_func (gpointer self);
static void peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self,
                                                          GtkButton* source);
static void _peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                              gpointer self);
static void peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self,
                                                        GtkButton* source);
static void _peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                            gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
gint peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self);
static gboolean ___lambda13_ (Block4Data* _data4_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda14_ (Block5Data* _data5_);
static void peek_ui_application_window_start_recording (PeekUiApplicationWindow* self);
static void ____lambda14__gtk_widget_hide (GtkWidget* _sender,
                                    gpointer self);
static gboolean ____lambda13__gsource_func (gpointer self);
static void peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self);
static void peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self);
static void ___lambda10_ (PeekUiApplicationWindow* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda10__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static cairo_region_t* peek_ui_application_window_create_region_from_widget (PeekUiApplicationWindow* self,
                                                                      GtkWidget* widget);
static GtkWidget* peek_ui_application_window_get_fallback_app_menu (PeekUiApplicationWindow* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda18_ (Block6Data* _data6_,
                  GtkWidget* child);
static void ___lambda18__gtk_callback (GtkWidget* widget,
                                gpointer self);
const gchar* peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self);
static gchar* peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self);
static void peek_ui_application_window_save_file (PeekUiApplicationWindow* self);
static void __lambda9_ (PeekUiApplicationWindow* self,
                 GObject* obj,
                 GAsyncResult* res);
static void peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self,
                                                   GFile* file);
static void ___lambda9__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self,
                                                            GFile* out_file);
gboolean peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self);
static void peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self,
                                                              GFile* file);
#define PEEK_APP_ID "com.uploadedlobster.peek"
const gchar* peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self,
                                                 const gchar* value);
static void peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self);
void peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self,
                                                       gboolean value);
void peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self,
                                                          gint value);
void peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self,
                                                           gint value);
void peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self,
                                                              const gchar* value);
static void peek_ui_application_window_finalize (GObject * obj);
static void _vala_peek_ui_application_window_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_peek_ui_application_window_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
peek_ui_application_window_get_instance_private (PeekUiApplicationWindow* self)
{
	return G_STRUCT_MEMBER_P (self, PeekUiApplicationWindow_private_offset);
}

static void
__lambda7_ (PeekUiApplicationWindow* self)
{
	peek_ui_application_window_enter_recording_state (self);
}

static void
___lambda7__peek_recording_screen_recorder_recording_started (PeekRecordingScreenRecorder* _sender,
                                                              gpointer self)
{
	__lambda7_ ((PeekUiApplicationWindow*) self);
}

static void
__lambda8_ (PeekUiApplicationWindow* self)
{
	self->priv->is_postprocessing = TRUE;
	peek_ui_application_window_show_file_chooser (self);
}

static void
___lambda8__peek_recording_screen_recorder_recording_postprocess_started (PeekRecordingScreenRecorder* _sender,
                                                                          gpointer self)
{
	__lambda8_ ((PeekUiApplicationWindow*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda11_ (PeekUiApplicationWindow* self,
             GFile* file)
{
	GFile* _tmp0_;
	g_return_if_fail (file != NULL);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->priv->in_file);
	self->priv->in_file = _tmp0_;
	peek_ui_application_window_try_save_file (self);
}

static void
___lambda11__peek_recording_screen_recorder_recording_finished (PeekRecordingScreenRecorder* _sender,
                                                                GFile* file,
                                                                gpointer self)
{
	__lambda11_ ((PeekUiApplicationWindow*) self, file);
}

static void
__lambda12_ (PeekUiApplicationWindow* self,
             gint status)
{
	FILE* _tmp0_;
	_tmp0_ = stderr;
	fprintf (_tmp0_, "Recording canceled with return code %i\n", status);
	peek_ui_application_window_leave_recording_state (self);
}

static void
___lambda12__peek_recording_screen_recorder_recording_aborted (PeekRecordingScreenRecorder* _sender,
                                                               gint status,
                                                               gpointer self)
{
	__lambda12_ ((PeekUiApplicationWindow*) self, status);
}

static void
_peek_ui_application_window_toggle_recording_peek_application_toggle_recording (PeekApplication* _sender,
                                                                                gpointer self)
{
	peek_ui_application_window_toggle_recording ((PeekUiApplicationWindow*) self);
}

static void
_peek_ui_application_window_prepare_start_recording_peek_application_start_recording (PeekApplication* _sender,
                                                                                      gpointer self)
{
	peek_ui_application_window_prepare_start_recording ((PeekUiApplicationWindow*) self);
}

static void
_peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording (PeekApplication* _sender,
                                                                                    gpointer self)
{
	peek_ui_application_window_prepare_stop_recording ((PeekUiApplicationWindow*) self);
}

static void
__lambda15_ (PeekUiApplicationWindow* self)
{
	peek_ui_application_window_show_size_indicator (self);
}

static void
___lambda15__gtk_widget_show (GtkWidget* _sender,
                              gpointer self)
{
	__lambda15_ ((PeekUiApplicationWindow*) self);
}

PeekUiApplicationWindow*
peek_ui_application_window_construct (GType object_type,
                                      PeekApplication* application,
                                      PeekRecordingScreenRecorder* recorder)
{
	PeekUiApplicationWindow * self = NULL;
	PeekRecordingScreenRecorder* _tmp0_;
	PeekRecordingScreenRecorder* _tmp1_;
	PeekRecordingScreenRecorder* _tmp2_;
	PeekRecordingScreenRecorder* _tmp3_;
	GSettings* _tmp4_;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GSettings* _tmp8_;
	GtkSettings* _tmp9_;
	GSettings* _tmp10_;
	PeekRecordingScreenRecorder* _tmp11_;
	GSettings* _tmp12_;
	PeekRecordingScreenRecorder* _tmp13_;
	GSettings* _tmp14_;
	PeekRecordingScreenRecorder* _tmp15_;
	GSettings* _tmp16_;
	PeekRecordingScreenRecorder* _tmp17_;
	GSettings* _tmp18_;
	GSettings* _tmp19_;
	GtkButton* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	g_return_val_if_fail (application != NULL, NULL);
	g_return_val_if_fail (recorder != NULL, NULL);
	self = (PeekUiApplicationWindow*) g_object_new (object_type, "application", application, NULL);
	peek_ui_application_window_set_recorder (self, recorder);
	_tmp0_ = self->priv->_recorder;
	g_signal_connect_object (_tmp0_, "recording-started", (GCallback) ___lambda7__peek_recording_screen_recorder_recording_started, self, 0);
	_tmp1_ = self->priv->_recorder;
	g_signal_connect_object (_tmp1_, "recording-postprocess-started", (GCallback) ___lambda8__peek_recording_screen_recorder_recording_postprocess_started, self, 0);
	_tmp2_ = self->priv->_recorder;
	g_signal_connect_object (_tmp2_, "recording-finished", (GCallback) ___lambda11__peek_recording_screen_recorder_recording_finished, self, 0);
	_tmp3_ = self->priv->_recorder;
	g_signal_connect_object (_tmp3_, "recording-aborted", (GCallback) ___lambda12__peek_recording_screen_recorder_recording_aborted, self, 0);
	g_signal_connect_object (application, "toggle-recording", (GCallback) _peek_ui_application_window_toggle_recording_peek_application_toggle_recording, self, 0);
	g_signal_connect_object (application, "start-recording", (GCallback) _peek_ui_application_window_prepare_start_recording_peek_application_start_recording, self, 0);
	g_signal_connect_object (application, "stop-recording", (GCallback) _peek_ui_application_window_prepare_stop_recording_peek_application_stop_recording, self, 0);
	_tmp4_ = peek_application_get_app_settings ();
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp4_;
	_tmp5_ = self->priv->settings;
	g_settings_bind (_tmp5_, "interface-open-file-manager", (GObject*) self, "open_file_manager", G_SETTINGS_BIND_DEFAULT);
	_tmp6_ = self->priv->settings;
	g_settings_bind (_tmp6_, "interface-size-indicator-delay", (GObject*) self, "size_indicator_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp7_ = self->priv->settings;
	g_settings_bind (_tmp7_, "interface-default-file-name-format", (GObject*) self, "default_file_name_format", G_SETTINGS_BIND_DEFAULT);
	_tmp8_ = self->priv->settings;
	_tmp9_ = gtk_widget_get_settings ((GtkWidget*) self);
	g_settings_bind (_tmp8_, "interface-prefer-dark-theme", (GObject*) _tmp9_, "gtk_application_prefer_dark_theme", G_SETTINGS_BIND_DEFAULT);
	_tmp10_ = self->priv->settings;
	_tmp11_ = self->priv->_recorder;
	g_settings_bind (_tmp10_, "recording-output-format", (GObject*) _tmp11_, "output_format", G_SETTINGS_BIND_DEFAULT);
	_tmp12_ = self->priv->settings;
	_tmp13_ = self->priv->_recorder;
	g_settings_bind (_tmp12_, "recording-framerate", (GObject*) _tmp13_, "framerate", G_SETTINGS_BIND_DEFAULT);
	_tmp14_ = self->priv->settings;
	_tmp15_ = self->priv->_recorder;
	g_settings_bind (_tmp14_, "recording-downsample", (GObject*) _tmp15_, "downsample", G_SETTINGS_BIND_DEFAULT);
	_tmp16_ = self->priv->settings;
	_tmp17_ = self->priv->_recorder;
	g_settings_bind (_tmp16_, "recording-capture-mouse", (GObject*) _tmp17_, "capture_mouse", G_SETTINGS_BIND_DEFAULT);
	_tmp18_ = self->priv->settings;
	g_settings_bind (_tmp18_, "recording-start-delay", (GObject*) self, "recording_start_delay", G_SETTINGS_BIND_DEFAULT);
	_tmp19_ = self->priv->settings;
	g_settings_bind (_tmp19_, "persist-save-folder", (GObject*) self, "save_folder", G_SETTINGS_BIND_DEFAULT);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	peek_ui_application_window_load_geometry (self);
	peek_ui_application_window_on_window_screen_changed (self, NULL);
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) ___lambda15__gtk_widget_show, self, 0);
	_tmp20_ = self->priv->stop_button;
	_tmp21_ = gtk_button_get_label (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = g_strdup (_tmp22_);
	_g_free0 (self->priv->stop_button_label);
	self->priv->stop_button_label = _tmp23_;
	peek_ui_application_window_set_close_button_position (self);
	return self;
}

PeekUiApplicationWindow*
peek_ui_application_window_new (PeekApplication* application,
                                PeekRecordingScreenRecorder* recorder)
{
	return peek_ui_application_window_construct (PEEK_UI_TYPE_APPLICATION_WINDOW, application, recorder);
}

static gboolean
peek_ui_application_window_real_configure_event (GtkWidget* base,
                                                 GdkEventConfigure* event)
{
	PeekUiApplicationWindow * self;
	PeekRecordingScreenRecorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
	self = (PeekUiApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		PeekRecordingRecordingArea new_recording_area = {0};
		PeekRecordingRecordingArea _tmp3_ = {0};
		PeekRecordingRecordingArea _tmp4_;
		peek_ui_application_window_get_recording_area (self, &_tmp3_);
		new_recording_area = _tmp3_;
		_tmp4_ = self->priv->active_recording_area;
		if (!peek_recording_recording_area_equals (&new_recording_area, &_tmp4_)) {
			PeekRecordingScreenRecorder* _tmp5_;
			_tmp5_ = self->priv->_recorder;
			peek_recording_screen_recorder_cancel (_tmp5_);
		}
		peek_recording_recording_area_destroy (&new_recording_area);
	}
	result = GTK_WIDGET_CLASS (peek_ui_application_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_application_window_get_type (), GtkApplicationWindow), event);
	return result;
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
	if (self) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("true");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("false");
		result = _tmp1_;
		return result;
	}
}

static void
___lambda17_ (PeekUiApplicationWindow* self,
              PeekUiApplicationWindow* file)
{
	g_return_if_fail (file != NULL);
	gtk_window_close ((GtkWindow*) self);
}

static void
____lambda17__peek_ui_application_window_recording_finished (PeekUiApplicationWindow* _sender,
                                                             gpointer self)
{
	___lambda17_ ((PeekUiApplicationWindow*) self, _sender);
}

static gboolean
peek_ui_application_window_real_delete_event (GtkWidget* base,
                                              GdkEventAny* event)
{
	PeekUiApplicationWindow * self;
	PeekRecordingScreenRecorder* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	PeekRecordingScreenRecorder* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	gboolean result = FALSE;
	self = (PeekUiApplicationWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_recorder;
	_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = bool_to_string (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = bool_to_string (self->priv->is_postprocessing);
	_tmp6_ = _tmp5_;
	g_debug ("application-window.vala:169: delete_event: recorder.is_recording=%s, w" \
"indow.is_postprocessing=%s", _tmp4_, _tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_tmp8_ = self->priv->_recorder;
	_tmp9_ = peek_recording_screen_recorder_get_is_recording (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = self->priv->is_postprocessing;
	}
	if (_tmp7_) {
		PeekRecordingScreenRecorder* _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp13_;
		g_signal_connect_object (self, "recording-finished", (GCallback) ____lambda17__peek_ui_application_window_recording_finished, self, 0);
		_tmp11_ = self->priv->_recorder;
		_tmp12_ = peek_recording_screen_recorder_get_is_recording (_tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_) {
			PeekRecordingScreenRecorder* _tmp14_;
			_tmp14_ = self->priv->_recorder;
			peek_recording_screen_recorder_cancel (_tmp14_);
		}
		gtk_widget_hide ((GtkWidget*) self);
		result = TRUE;
		return result;
	}
	if (self->priv->size_indicator_timeout != ((guint) 0)) {
		g_source_remove (self->priv->size_indicator_timeout);
	}
	if (self->priv->delay_indicator_timeout != ((guint) 0)) {
		g_source_remove (self->priv->delay_indicator_timeout);
	}
	peek_ui_application_window_save_geometry (self);
	result = FALSE;
	return result;
}

void
peek_ui_application_window_on_window_screen_changed (PeekUiApplicationWindow* self,
                                                     GdkScreen* previous_screen)
{
	GdkScreen* screen = NULL;
	GdkScreen* _tmp0_;
	GdkScreen* _tmp1_;
	GdkVisual* visual = NULL;
	GdkScreen* _tmp2_;
	GdkVisual* _tmp3_;
	GdkVisual* _tmp4_;
	GdkVisual* _tmp5_;
	GdkVisual* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_window_get_screen ((GtkWindow*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	screen = _tmp1_;
	_tmp2_ = screen;
	_tmp3_ = gdk_screen_get_rgba_visual (_tmp2_);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	visual = _tmp4_;
	_tmp5_ = visual;
	if (_tmp5_ == NULL) {
		FILE* _tmp6_;
		GdkScreen* _tmp7_;
		GdkVisual* _tmp8_;
		GdkVisual* _tmp9_;
		_tmp6_ = stderr;
		fprintf (_tmp6_, "Screen does not support alpha channels!");
		_tmp7_ = screen;
		_tmp8_ = gdk_screen_get_system_visual (_tmp7_);
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (visual);
		visual = _tmp9_;
		self->priv->screen_supports_alpha = FALSE;
	} else {
		self->priv->screen_supports_alpha = TRUE;
	}
	_tmp10_ = visual;
	gtk_widget_set_visual ((GtkWidget*) self, _tmp10_);
	_g_object_unref0 (visual);
	_g_object_unref0 (screen);
}

static void
_peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed (GtkWidget* _sender,
                                                                                GdkScreen* previous_screen,
                                                                                gpointer self)
{
	peek_ui_application_window_on_window_screen_changed ((PeekUiApplicationWindow*) self, previous_screen);
}

static gboolean
peek_ui_application_window_on_recording_view_draw (PeekUiApplicationWindow* self,
                                                   GtkWidget* widget,
                                                   cairo_t* ctx)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (ctx != NULL, FALSE);
	if (self->priv->screen_supports_alpha) {
		cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.0);
	} else {
		cairo_set_source_rgb (ctx, 0.0, 0.0, 0.0);
	}
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
	cairo_paint (ctx);
	cairo_fill (ctx);
	peek_ui_application_window_update_input_shape (self);
	result = FALSE;
	return result;
}

static gboolean
_peek_ui_application_window_on_recording_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                    cairo_t* cr,
                                                                    gpointer self)
{
	gboolean result;
	result = peek_ui_application_window_on_recording_view_draw ((PeekUiApplicationWindow*) self, _sender, cr);
	return result;
}

static void
peek_ui_application_window_on_recording_view_size_allocate (PeekUiApplicationWindow* self,
                                                            GtkAllocation* allocation)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (allocation != NULL);
	peek_ui_application_window_show_size_indicator (self);
}

static void
_peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                      GtkAllocation* allocation,
                                                                                      gpointer self)
{
	peek_ui_application_window_on_recording_view_size_allocate ((PeekUiApplicationWindow*) self, allocation);
}

static gboolean
_____lambda16_ (PeekUiApplicationWindow* self)
{
	GtkLabel* _tmp0_;
	gboolean result = FALSE;
	self->priv->size_indicator_timeout = (guint) 0;
	_tmp0_ = self->priv->size_indicator;
	gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
	result = FALSE;
	return result;
}

static gboolean
______lambda16__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda16_ ((PeekUiApplicationWindow*) self);
	return result;
}

static void
peek_ui_application_window_show_size_indicator (PeekUiApplicationWindow* self)
{
	g_return_if_fail (self != NULL);
	if (gtk_widget_get_realized ((GtkWidget*) self)) {
		PeekRecordingRecordingArea area = {0};
		PeekRecordingRecordingArea _tmp0_ = {0};
		peek_ui_application_window_get_recording_area (self, &_tmp0_);
		area = _tmp0_;
		if (peek_ui_application_window_get_window_width (self) < PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
			GtkButton* _tmp1_;
			GtkButton* _tmp2_;
			_tmp1_ = self->priv->record_button;
			peek_gtk_helper_hide_button_label (_tmp1_);
			_tmp2_ = self->priv->stop_button;
			peek_gtk_helper_hide_button_label (_tmp2_);
		} else {
			GtkButton* _tmp3_;
			GtkButton* _tmp4_;
			_tmp3_ = self->priv->record_button;
			peek_gtk_helper_show_button_label (_tmp3_);
			_tmp4_ = self->priv->stop_button;
			peek_gtk_helper_show_button_label (_tmp4_);
		}
		if (!self->priv->is_recording) {
			GString* size_label = NULL;
			GString* _tmp5_;
			GString* _tmp6_;
			PeekRecordingRecordingArea _tmp7_;
			PeekRecordingRecordingArea _tmp8_;
			GtkLabel* _tmp9_;
			GString* _tmp10_;
			const gchar* _tmp11_;
			GtkLabel* _tmp12_;
			PeekRecordingScreenRecorder* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			_tmp5_ = g_string_new ("");
			size_label = _tmp5_;
			_tmp6_ = size_label;
			_tmp7_ = area;
			_tmp8_ = area;
			g_string_printf (_tmp6_, "%i x %i", _tmp7_.width, _tmp8_.height);
			_tmp9_ = self->priv->size_indicator;
			_tmp10_ = size_label;
			_tmp11_ = _tmp10_->str;
			gtk_label_set_text (_tmp9_, _tmp11_);
			_tmp12_ = self->priv->size_indicator;
			gtk_widget_show ((GtkWidget*) _tmp12_);
			if (self->priv->size_indicator_timeout != ((guint) 0)) {
				g_source_remove (self->priv->size_indicator_timeout);
			}
			_tmp13_ = self->priv->_recorder;
			_tmp14_ = peek_recording_screen_recorder_get_is_recording (_tmp13_);
			_tmp15_ = _tmp14_;
			if (!_tmp15_) {
				GtkLabel* _tmp16_;
				gint _tmp17_;
				_tmp16_ = self->priv->size_indicator;
				gtk_widget_set_opacity ((GtkWidget*) _tmp16_, 1.0);
				_tmp17_ = self->priv->_size_indicator_delay;
				self->priv->size_indicator_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp17_, ______lambda16__gsource_func, g_object_ref (self), g_object_unref);
			}
			_g_string_free0 (size_label);
		}
		peek_recording_recording_area_destroy (&area);
	}
}

static void
peek_ui_application_window_on_record_button_clicked (PeekUiApplicationWindow* self,
                                                     GtkButton* source)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	peek_ui_application_window_prepare_start_recording (self);
}

static void
_peek_ui_application_window_on_record_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self)
{
	peek_ui_application_window_on_record_button_clicked ((PeekUiApplicationWindow*) self, _sender);
}

static void
peek_ui_application_window_on_stop_button_clicked (PeekUiApplicationWindow* self,
                                                   GtkButton* source)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	peek_ui_application_window_prepare_stop_recording (self);
}

static void
_peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                       gpointer self)
{
	peek_ui_application_window_on_stop_button_clicked ((PeekUiApplicationWindow*) self, _sender);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data5_->_data4_->self;
		block4_data_unref (_data5_->_data4_);
		_data5_->_data4_ = NULL;
		g_slice_free (Block5Data, _data5_);
	}
}

static void
___lambda14_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	PeekUiApplicationWindow* self;
	GtkLabel* _tmp0_;
	_data4_ = _data5_->_data4_;
	self = _data4_->self;
	_tmp0_ = self->priv->delay_indicator;
	g_signal_handler_disconnect ((GObject*) _tmp0_, _data5_->hide_handler);
	peek_ui_application_window_start_recording (self);
}

static void
____lambda14__gtk_widget_hide (GtkWidget* _sender,
                               gpointer self)
{
	___lambda14_ (self);
}

static gboolean
___lambda13_ (Block4Data* _data4_)
{
	PeekUiApplicationWindow* self;
	gboolean result = FALSE;
	self = _data4_->self;
	_data4_->delay -= 1;
	if (_data4_->delay == 0) {
		Block5Data* _data5_;
		GtkLabel* _tmp0_;
		gulong _tmp1_;
		GtkLabel* _tmp2_;
		_data5_ = g_slice_new0 (Block5Data);
		_data5_->_ref_count_ = 1;
		_data5_->_data4_ = block4_data_ref (_data4_);
		self->priv->delay_indicator_timeout = (guint) 0;
		_data5_->hide_handler = (gulong) 0;
		_tmp0_ = self->priv->delay_indicator;
		_tmp1_ = g_signal_connect_data ((GtkWidget*) _tmp0_, "hide", (GCallback) ____lambda14__gtk_widget_hide, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
		_data5_->hide_handler = _tmp1_;
		_tmp2_ = self->priv->delay_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp2_);
		result = FALSE;
		block5_data_unref (_data5_);
		_data5_ = NULL;
		return result;
	} else {
		GtkLabel* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = self->priv->delay_indicator;
		_tmp4_ = g_strdup_printf ("%i", _data4_->delay);
		_tmp5_ = _tmp4_;
		gtk_label_set_text (_tmp3_, _tmp5_);
		_g_free0 (_tmp5_);
		result = TRUE;
		return result;
	}
}

static gboolean
____lambda13__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda13_ (self);
	return result;
}

static void
peek_ui_application_window_prepare_start_recording (PeekUiApplicationWindow* self)
{
	Block4Data* _data4_;
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	if (self->priv->is_recording) {
		block4_data_unref (_data4_);
		_data4_ = NULL;
		return;
	}
	peek_ui_application_window_enter_recording_state (self);
	_tmp0_ = self->priv->_recording_start_delay;
	_data4_->delay = _tmp0_;
	if (_data4_->delay > 0) {
		GtkLabel* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkLabel* _tmp4_;
		GtkLabel* _tmp5_;
		_tmp1_ = self->priv->delay_indicator;
		_tmp2_ = g_strdup_printf ("%i", _data4_->delay);
		_tmp3_ = _tmp2_;
		gtk_label_set_text (_tmp1_, _tmp3_);
		_g_free0 (_tmp3_);
		_tmp4_ = self->priv->delay_indicator;
		gtk_widget_show ((GtkWidget*) _tmp4_);
		_tmp5_ = self->priv->size_indicator;
		gtk_widget_hide ((GtkWidget*) _tmp5_);
		self->priv->delay_indicator_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, ____lambda13__gsource_func, block4_data_ref (_data4_), block4_data_unref);
	} else {
		peek_ui_application_window_start_recording (self);
	}
	block4_data_unref (_data4_);
	_data4_ = NULL;
}

static void
peek_ui_application_window_prepare_stop_recording (PeekUiApplicationWindow* self)
{
	g_return_if_fail (self != NULL);
	if (!self->priv->is_recording) {
		return;
	}
	if (self->priv->delay_indicator_timeout != ((guint) 0)) {
		g_source_remove (self->priv->delay_indicator_timeout);
		self->priv->delay_indicator_timeout = (guint) 0;
		peek_ui_application_window_leave_recording_state (self);
	} else {
		PeekRecordingScreenRecorder* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->_recorder;
		_tmp1_ = peek_recording_screen_recorder_get_is_recording (_tmp0_);
		_tmp2_ = _tmp1_;
		if (!_tmp2_) {
			return;
		} else {
			GtkButton* _tmp3_;
			PeekRecordingScreenRecorder* _tmp5_;
			_tmp3_ = self->priv->stop_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
			if (peek_ui_application_window_get_window_width (self) >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
				GtkButton* _tmp4_;
				_tmp4_ = self->priv->stop_button;
				gtk_button_set_label (_tmp4_, _ ("Rendering…"));
			}
			_tmp5_ = self->priv->_recorder;
			peek_recording_screen_recorder_stop (_tmp5_);
		}
	}
}

static void
peek_ui_application_window_toggle_recording (PeekUiApplicationWindow* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->is_recording) {
		peek_ui_application_window_prepare_stop_recording (self);
	} else {
		peek_ui_application_window_prepare_start_recording (self);
	}
}

static void
peek_ui_application_window_start_recording (PeekUiApplicationWindow* self)
{
	PeekRecordingRecordingArea area = {0};
	PeekRecordingRecordingArea _tmp0_ = {0};
	PeekRecordingRecordingArea _tmp1_;
	PeekRecordingRecordingArea _tmp2_;
	PeekRecordingRecordingArea _tmp3_;
	PeekRecordingRecordingArea _tmp4_;
	PeekRecordingRecordingArea _tmp5_;
	PeekRecordingRecordingArea _tmp6_;
	PeekRecordingRecordingArea _tmp7_ = {0};
	PeekRecordingScreenRecorder* _tmp8_;
	PeekRecordingRecordingArea _tmp9_;
	g_return_if_fail (self != NULL);
	peek_ui_application_window_get_recording_area (self, &_tmp0_);
	area = _tmp0_;
	_tmp1_ = area;
	_tmp2_ = area;
	_tmp3_ = area;
	_tmp4_ = area;
	g_debug ("application-window.vala:348: Recording area: %i, %i, %i, %i\n", _tmp1_.left, _tmp2_.top, _tmp3_.width, _tmp4_.height);
	_tmp5_ = area;
	_tmp6_ = _tmp5_;
	peek_recording_recording_area_copy (&_tmp6_, &_tmp7_);
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
	self->priv->active_recording_area = _tmp7_;
	_tmp8_ = self->priv->_recorder;
	_tmp9_ = area;
	if (!peek_recording_screen_recorder_record (_tmp8_, &_tmp9_)) {
		peek_ui_application_window_leave_recording_state (self);
	}
	peek_recording_recording_area_destroy (&area);
}

static void
peek_ui_application_window_enter_recording_state (PeekUiApplicationWindow* self)
{
	g_return_if_fail (self != NULL);
	if (!self->priv->is_recording) {
		GtkLabel* _tmp0_;
		GtkButton* _tmp1_;
		GtkButton* _tmp4_;
		GtkButton* _tmp5_;
		self->priv->is_recording = TRUE;
		_tmp0_ = self->priv->size_indicator;
		gtk_widget_set_opacity ((GtkWidget*) _tmp0_, 0.0);
		_tmp1_ = self->priv->record_button;
		gtk_widget_hide ((GtkWidget*) _tmp1_);
		if (peek_ui_application_window_get_window_width (self) >= PEEK_UI_APPLICATION_WINDOW_SMALL_WINDOW_SIZE) {
			GtkButton* _tmp2_;
			const gchar* _tmp3_;
			_tmp2_ = self->priv->stop_button;
			_tmp3_ = self->priv->stop_button_label;
			gtk_button_set_label (_tmp2_, _tmp3_);
		}
		_tmp4_ = self->priv->stop_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, TRUE);
		_tmp5_ = self->priv->stop_button;
		gtk_widget_show ((GtkWidget*) _tmp5_);
		peek_ui_application_window_freeze_window_size (self);
		gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	}
}

static void
___lambda10_ (PeekUiApplicationWindow* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean delete_success = FALSE;
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		_tmp0_ = self->priv->in_file;
		delete_success = g_file_delete_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch21_g_error;
		}
		_tmp1_ = bool_to_string (delete_success);
		_tmp2_ = _tmp1_;
		g_debug ("application-window.vala:386: Temp file deleted: %s\n", _tmp2_);
		_g_free0 (_tmp2_);
	}
	goto __finally21;
	__catch21_g_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = stderr;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		fprintf (_tmp3_, "Temp file delete error: %s\n", _tmp5_);
		_g_error_free0 (e);
	}
	__finally21:
	{
		GError* _inner_error1_ = NULL;
		_g_object_unref0 (self->priv->in_file);
		self->priv->in_file = NULL;
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_signal_emit (self, peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL], 0);
}

static void
____lambda10__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	___lambda10_ ((PeekUiApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}

static void
peek_ui_application_window_leave_recording_state (PeekUiApplicationWindow* self)
{
	GtkLabel* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GFile* _tmp3_;
	g_return_if_fail (self != NULL);
	_g_object_unref0 (self->priv->out_file);
	self->priv->out_file = NULL;
	_tmp0_ = self->priv->delay_indicator;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	self->priv->is_recording = FALSE;
	self->priv->is_postprocessing = FALSE;
	_tmp1_ = self->priv->stop_button;
	gtk_widget_hide ((GtkWidget*) _tmp1_);
	_tmp2_ = self->priv->record_button;
	gtk_widget_show ((GtkWidget*) _tmp2_);
	peek_ui_application_window_unfreeze_window_size (self);
	_tmp3_ = self->priv->in_file;
	if (_tmp3_ != NULL) {
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		_tmp4_ = self->priv->in_file;
		_tmp5_ = g_file_get_uri (_tmp4_);
		_tmp6_ = _tmp5_;
		g_debug ("application-window.vala:382: Deleting temp file %s\n", _tmp6_);
		_g_free0 (_tmp6_);
		_tmp7_ = self->priv->in_file;
		g_file_delete_async (_tmp7_, G_PRIORITY_DEFAULT, NULL, ____lambda10__gasync_ready_callback, g_object_ref (self));
	} else {
		g_signal_emit (self, peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL], 0);
	}
}

static void
peek_ui_application_window_update_input_shape (PeekUiApplicationWindow* self)
{
	cairo_region_t* window_region = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	cairo_region_t* _tmp2_;
	cairo_region_t* recording_view_region = NULL;
	GtkWidget* _tmp3_;
	cairo_region_t* _tmp4_;
	cairo_region_t* _tmp5_;
	cairo_region_t* _tmp6_;
	GtkWidget* fallback_app_menu = NULL;
	GtkWidget* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkWidget* _tmp9_;
	cairo_region_t* _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	_tmp1_ = gtk_widget_get_toplevel (_tmp0_);
	_tmp2_ = peek_ui_application_window_create_region_from_widget (self, _tmp1_);
	window_region = _tmp2_;
	_tmp3_ = self->priv->recording_view;
	_tmp4_ = peek_ui_application_window_create_region_from_widget (self, _tmp3_);
	recording_view_region = _tmp4_;
	_tmp5_ = window_region;
	_tmp6_ = recording_view_region;
	cairo_region_subtract (_tmp5_, _tmp6_);
	_tmp7_ = peek_ui_application_window_get_fallback_app_menu (self);
	fallback_app_menu = _tmp7_;
	_tmp9_ = fallback_app_menu;
	if (_tmp9_ != NULL) {
		GtkWidget* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp10_ = fallback_app_menu;
		_tmp11_ = gtk_widget_get_visible (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp8_ = _tmp12_;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		cairo_region_t* app_menu_region = NULL;
		GtkWidget* _tmp13_;
		cairo_region_t* _tmp14_;
		cairo_region_t* _tmp15_;
		cairo_region_t* _tmp16_;
		_tmp13_ = fallback_app_menu;
		_tmp14_ = peek_ui_application_window_create_region_from_widget (self, _tmp13_);
		app_menu_region = _tmp14_;
		_tmp15_ = window_region;
		_tmp16_ = app_menu_region;
		cairo_region_union (_tmp15_, _tmp16_);
		_cairo_region_destroy0 (app_menu_region);
	}
	_tmp17_ = window_region;
	gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp17_);
	_g_object_unref0 (fallback_app_menu);
	_cairo_region_destroy0 (recording_view_region);
	_cairo_region_destroy0 (window_region);
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		PeekUiApplicationWindow* self;
		self = _data6_->self;
		_g_object_unref0 (_data6_->fallback_app_menu);
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static void
__lambda18_ (Block6Data* _data6_,
             GtkWidget* child)
{
	PeekUiApplicationWindow* self;
	self = _data6_->self;
	g_return_if_fail (child != NULL);
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_popover_get_type ())) {
		GtkWidget* _tmp0_;
		_tmp0_ = _g_object_ref0 (child);
		_g_object_unref0 (_data6_->fallback_app_menu);
		_data6_->fallback_app_menu = _tmp0_;
	}
}

static void
___lambda18__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
	__lambda18_ (self, widget);
}

static GtkWidget*
peek_ui_application_window_get_fallback_app_menu (PeekUiApplicationWindow* self)
{
	Block6Data* _data6_;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp1_ = _tmp0_;
	if (gtk_application_prefers_app_menu (_tmp1_)) {
		result = NULL;
		block6_data_unref (_data6_);
		_data6_ = NULL;
		return result;
	}
	_data6_->fallback_app_menu = NULL;
	gtk_container_forall ((GtkContainer*) self, ___lambda18__gtk_callback, _data6_);
	_tmp2_ = _data6_->fallback_app_menu;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	block6_data_unref (_data6_);
	_data6_ = NULL;
	return result;
}

static void
peek_ui_application_window_freeze_window_size (PeekUiApplicationWindow* self)
{
	gint width = 0;
	gint height = 0;
	g_return_if_fail (self != NULL);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	g_debug ("application-window.vala:435: freeze_window_size w: %d, h: %d", width, height);
	gtk_widget_set_size_request ((GtkWidget*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
}

static void
peek_ui_application_window_unfreeze_window_size (PeekUiApplicationWindow* self)
{
	gint width = 0;
	gint height = 0;
	g_return_if_fail (self != NULL);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	g_debug ("application-window.vala:443: unfreeze_window_size w: %d, h: %d", width, height);
	gtk_widget_set_size_request ((GtkWidget*) self, 0, 0);
	gtk_window_set_default_size ((GtkWindow*) self, width, height);
	gtk_window_set_resizable ((GtkWindow*) self, TRUE);
}

static cairo_region_t*
peek_ui_application_window_create_region_from_widget (PeekUiApplicationWindow* self,
                                                      GtkWidget* widget)
{
	cairo_rectangle_int_t rectangle = {0};
	cairo_rectangle_int_t _tmp0_ = {0};
	GtkWidget* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	cairo_region_t* region = NULL;
	cairo_rectangle_int_t _tmp4_;
	cairo_region_t* _tmp5_;
	cairo_region_t* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (widget != NULL, NULL);
	memset (&_tmp0_, 0, sizeof (cairo_rectangle_int_t));
	_tmp0_.width = gtk_widget_get_allocated_width (widget);
	_tmp0_.height = gtk_widget_get_allocated_height (widget);
	rectangle = _tmp0_;
	_tmp1_ = gtk_widget_get_toplevel (widget);
	gtk_widget_translate_coordinates (widget, _tmp1_, 0, 0, &_tmp2_, &_tmp3_);
	rectangle.x = _tmp2_;
	rectangle.y = _tmp3_;
	_tmp4_ = rectangle;
	_tmp5_ = cairo_region_create_rectangle (&_tmp4_);
	region = _tmp5_;
	result = region;
	return result;
}

static void
peek_ui_application_window_get_recording_area (PeekUiApplicationWindow* self,
                                               PeekRecordingRecordingArea* result)
{
	GtkWidget* _tmp0_;
	PeekRecordingRecordingArea _tmp1_ = {0};
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->recording_view;
	peek_recording_recording_area_create_for_widget (_tmp0_, &_tmp1_);
	*result = _tmp1_;
	return;
}

static void
peek_ui_application_window_show_file_chooser (PeekUiApplicationWindow* self)
{
	GtkFileChooserDialog* chooser = NULL;
	GtkFileChooserDialog* _tmp0_;
	GtkWidget* ok_button = NULL;
	GtkFileChooserDialog* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkStyleContext* _tmp5_;
	GtkFileChooserDialog* _tmp6_;
	gchar* extension = NULL;
	PeekRecordingScreenRecorder* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* filename = NULL;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp17_;
	GtkFileFilter* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkFileChooserDialog* _tmp22_;
	GtkFileFilter* _tmp23_;
	gchar* folder = NULL;
	gchar* _tmp24_;
	GtkFileChooserDialog* _tmp25_;
	const gchar* _tmp26_;
	GDateTime* now = NULL;
	GDateTime* _tmp27_;
	gchar* default_name = NULL;
	GDateTime* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	GtkFileChooserDialog* _tmp31_;
	const gchar* _tmp32_;
	GtkFileChooserDialog* _tmp33_;
	GtkFileChooserDialog* _tmp40_;
	g_return_if_fail (self != NULL);
	_tmp0_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Save animation"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Cancel"), GTK_RESPONSE_CANCEL, NULL);
	g_object_ref_sink (_tmp0_);
	chooser = _tmp0_;
	_tmp1_ = chooser;
	_tmp2_ = gtk_dialog_add_button ((GtkDialog*) _tmp1_, _ ("_Save"), (gint) GTK_RESPONSE_ACCEPT);
	_tmp3_ = _g_object_ref0 (_tmp2_);
	ok_button = _tmp3_;
	_tmp4_ = ok_button;
	_tmp5_ = gtk_widget_get_style_context (_tmp4_);
	gtk_style_context_add_class (_tmp5_, "suggested-action");
	_tmp6_ = chooser;
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp6_, TRUE);
	_tmp7_ = self->priv->_recorder;
	_tmp8_ = peek_recording_screen_recorder_get_output_format (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = peek_utils_get_file_extension_for_format (_tmp9_);
	extension = _tmp10_;
	_tmp11_ = self->priv->_default_file_name_format;
	_tmp12_ = g_strconcat (_tmp11_, ".", NULL);
	_tmp13_ = _tmp12_;
	_tmp14_ = extension;
	_tmp15_ = g_strconcat (_tmp13_, _tmp14_, NULL);
	_tmp16_ = _tmp15_;
	_g_free0 (_tmp13_);
	filename = _tmp16_;
	_tmp17_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp17_);
	filter = _tmp17_;
	_tmp18_ = filter;
	_tmp19_ = extension;
	_tmp20_ = g_strconcat ("*.", _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	gtk_file_filter_add_pattern (_tmp18_, _tmp21_);
	_g_free0 (_tmp21_);
	_tmp22_ = chooser;
	_tmp23_ = filter;
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp22_, _tmp23_);
	_tmp24_ = peek_ui_application_window_load_preferred_save_folder (self);
	folder = _tmp24_;
	_tmp25_ = chooser;
	_tmp26_ = folder;
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp25_, _tmp26_);
	_tmp27_ = g_date_time_new_now_local ();
	now = _tmp27_;
	_tmp28_ = now;
	_tmp29_ = filename;
	_tmp30_ = g_date_time_format (_tmp28_, _tmp29_);
	default_name = _tmp30_;
	_tmp31_ = chooser;
	_tmp32_ = default_name;
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp31_, _tmp32_);
	g_debug ("application-window.vala:499: Showing file chooser");
	_tmp33_ = chooser;
	if (gtk_dialog_run ((GtkDialog*) _tmp33_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		GtkFileChooserDialog* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		GtkFileChooserDialog* _tmp37_;
		GFile* _tmp38_;
		_tmp34_ = chooser;
		_tmp35_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp34_);
		_tmp36_ = _tmp35_;
		g_debug ("application-window.vala:501: Selected file %s", _tmp36_);
		_g_free0 (_tmp36_);
		_tmp37_ = chooser;
		_tmp38_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp37_);
		_g_object_unref0 (self->priv->out_file);
		self->priv->out_file = _tmp38_;
		peek_ui_application_window_try_save_file (self);
	} else {
		PeekRecordingScreenRecorder* _tmp39_;
		_tmp39_ = self->priv->_recorder;
		peek_recording_screen_recorder_cancel (_tmp39_);
		peek_ui_application_window_leave_recording_state (self);
	}
	_tmp40_ = chooser;
	g_signal_emit_by_name ((GtkDialog*) _tmp40_, "close");
	_g_free0 (default_name);
	_g_date_time_unref0 (now);
	_g_free0 (folder);
	_g_object_unref0 (filter);
	_g_free0 (filename);
	_g_free0 (extension);
	_g_object_unref0 (ok_button);
	_g_object_unref0 (chooser);
}

static void
peek_ui_application_window_try_save_file (PeekUiApplicationWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->in_file;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GFile* _tmp2_;
		_tmp2_ = self->priv->out_file;
		_tmp0_ = _tmp2_ == NULL;
	}
	if (_tmp0_) {
		return;
	}
	peek_ui_application_window_save_file (self);
}

static void
__lambda9_ (PeekUiApplicationWindow* self,
            GObject* obj,
            GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (res != NULL);
	{
		gboolean copy_success = FALSE;
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = self->priv->in_file;
		copy_success = g_file_copy_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch22_g_error;
		}
		_tmp1_ = bool_to_string (copy_success);
		_tmp2_ = _tmp1_;
		_tmp3_ = self->priv->out_file;
		_tmp4_ = g_file_get_uri (_tmp3_);
		_tmp5_ = _tmp4_;
		g_debug ("application-window.vala:528: File saved %s: %s", _tmp2_, _tmp5_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp2_);
		if (copy_success) {
			GFile* _tmp6_;
			_tmp6_ = self->priv->out_file;
			peek_ui_application_window_handle_saved_file (self, _tmp6_);
		} else {
			if (!copy_success) {
				FILE* _tmp7_;
				GFile* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				_tmp7_ = stderr;
				_tmp8_ = self->priv->out_file;
				_tmp9_ = g_file_get_uri (_tmp8_);
				_tmp10_ = _tmp9_;
				fprintf (_tmp7_, "Saving file %s failed.\n", _tmp10_);
				_g_free0 (_tmp10_);
			}
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
		FILE* _tmp11_;
		GError* _tmp12_;
		const gchar* _tmp13_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = stderr;
		_tmp12_ = e;
		_tmp13_ = _tmp12_->message;
		fprintf (_tmp11_, "File save error: %s\n", _tmp13_);
		_g_error_free0 (e);
	}
	__finally22:
	{
		GError* _inner_error1_ = NULL;
		peek_ui_application_window_leave_recording_state (self);
	}
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
___lambda9__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
	__lambda9_ ((PeekUiApplicationWindow*) self, source_object, res);
	g_object_unref (self);
}

static void
peek_ui_application_window_save_file (PeekUiApplicationWindow* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->in_file;
	_tmp1_ = self->priv->out_file;
	g_file_copy_async (_tmp0_, _tmp1_, G_FILE_COPY_OVERWRITE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, ___lambda9__gasync_ready_callback, g_object_ref (self));
}

static void
peek_ui_application_window_handle_saved_file (PeekUiApplicationWindow* self,
                                              GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	peek_ui_application_window_save_preferred_save_folder (self, file);
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = self->priv->_open_file_manager;
		_tmp0_ = _tmp3_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		peek_desktop_integration_launch_file_manager (file);
	} else {
		peek_ui_application_window_show_file_saved_notification (self, file);
	}
}

static void
peek_ui_application_window_show_file_saved_notification (PeekUiApplicationWindow* self,
                                                         GFile* file)
{
	GString* message = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GVariant* parameter = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GNotification* notification = NULL;
	GString* _tmp8_;
	const gchar* _tmp9_;
	GNotification* _tmp10_;
	GString* _tmp36_;
	const gchar* _tmp37_;
	GtkApplication* _tmp38_;
	GtkApplication* _tmp39_;
	GNotification* _tmp40_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = g_string_new ("");
	message = _tmp0_;
	_tmp1_ = message;
	_tmp2_ = g_file_get_basename (file);
	_tmp3_ = _tmp2_;
	g_string_printf (_tmp1_, _ ("Animation saved as “%s”"), _tmp3_);
	_g_free0 (_tmp3_);
	_tmp4_ = g_file_get_uri (file);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_variant_new_string (_tmp5_);
	g_variant_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	parameter = _tmp7_;
	_tmp8_ = message;
	_tmp9_ = _tmp8_->str;
	_tmp10_ = g_notification_new (_tmp9_);
	notification = _tmp10_;
	if (!peek_desktop_integration_is_cinnamon ()) {
		GNotification* _tmp11_;
		GThemedIcon* _tmp12_;
		GThemedIcon* _tmp13_;
		_tmp11_ = notification;
		_tmp12_ = (GThemedIcon*) g_themed_icon_new (PEEK_APP_ID);
		_tmp13_ = _tmp12_;
		g_notification_set_icon (_tmp11_, (GIcon*) _tmp13_);
		_g_object_unref0 (_tmp13_);
	} else {
		GtkIconTheme* icon_theme = NULL;
		GtkIconTheme* _tmp14_;
		GtkIconTheme* _tmp15_;
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp16_;
		GtkIconInfo* _tmp17_;
		gchar* icon_path = NULL;
		GtkIconInfo* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		_tmp14_ = gtk_icon_theme_get_default ();
		_tmp15_ = _g_object_ref0 (_tmp14_);
		icon_theme = _tmp15_;
		_tmp16_ = icon_theme;
		_tmp17_ = gtk_icon_theme_lookup_icon (_tmp16_, PEEK_APP_ID, 48, 0);
		icon_info = _tmp17_;
		_tmp18_ = icon_info;
		_tmp19_ = gtk_icon_info_get_filename (_tmp18_);
		_tmp20_ = g_strdup (_tmp19_);
		icon_path = _tmp20_;
		_tmp21_ = icon_path;
		g_debug ("application-window.vala:570: Using notification icon: %s", _tmp21_);
		_tmp22_ = icon_path;
		if (_tmp22_ != NULL) {
			GFileIcon* icon = NULL;
			const gchar* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			GFileIcon* _tmp26_;
			GFileIcon* _tmp27_;
			GNotification* _tmp28_;
			GFileIcon* _tmp29_;
			_tmp23_ = icon_path;
			_tmp24_ = g_file_new_for_path (_tmp23_);
			_tmp25_ = _tmp24_;
			_tmp26_ = (GFileIcon*) g_file_icon_new (_tmp25_);
			_tmp27_ = _tmp26_;
			_g_object_unref0 (_tmp25_);
			icon = _tmp27_;
			_tmp28_ = notification;
			_tmp29_ = icon;
			g_notification_set_icon (_tmp28_, (GIcon*) _tmp29_);
			_g_object_unref0 (icon);
		}
		_g_free0 (icon_path);
		_g_object_unref0 (icon_info);
		_g_object_unref0 (icon_theme);
	}
	if (!peek_desktop_integration_is_unity ()) {
		GNotification* _tmp30_;
		GNotification* _tmp31_;
		GVariant* _tmp32_;
		gboolean _tmp33_ = FALSE;
		_tmp30_ = notification;
		g_notification_set_body (_tmp30_, _ ("Click here to show the saved file in your file manager."));
		_tmp31_ = notification;
		_tmp32_ = parameter;
		g_notification_add_button_with_target_value (_tmp31_, _ ("Show in file manager"), "app.show-file", _tmp32_);
		if (!peek_desktop_integration_is_plasma ()) {
			_tmp33_ = !peek_desktop_integration_is_xfce ();
		} else {
			_tmp33_ = FALSE;
		}
		if (_tmp33_) {
			GNotification* _tmp34_;
			GVariant* _tmp35_;
			_tmp34_ = notification;
			_tmp35_ = parameter;
			g_notification_set_default_action_and_target_value (_tmp34_, "app.show-file", _tmp35_);
		}
	}
	_tmp36_ = message;
	_tmp37_ = _tmp36_->str;
	g_debug ("application-window.vala:595: Showing desktop notification: %s", _tmp37_);
	_tmp38_ = gtk_window_get_application ((GtkWindow*) self);
	_tmp39_ = _tmp38_;
	_tmp40_ = notification;
	g_application_send_notification ((GApplication*) _tmp39_, "peek-file-saved", _tmp40_);
	_g_object_unref0 (notification);
	_g_variant_unref0 (parameter);
	_g_string_free0 (message);
}

static gchar*
peek_ui_application_window_load_preferred_save_folder (PeekUiApplicationWindow* self)
{
	gchar* folder = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	_tmp1_ = g_strdup (_tmp0_);
	folder = _tmp1_;
	_tmp4_ = folder;
	if (_tmp4_ == NULL) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = folder;
		_tmp3_ = g_strcmp0 (_tmp5_, "") == 0;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp6_;
		_tmp6_ = folder;
		_tmp2_ = !g_file_test (_tmp6_, G_FILE_TEST_IS_DIR);
	}
	if (_tmp2_) {
		gchar* _tmp7_;
		_tmp7_ = peek_desktop_integration_get_video_folder ();
		_g_free0 (folder);
		folder = _tmp7_;
	}
	result = folder;
	return result;
}

static void
peek_ui_application_window_save_preferred_save_folder (PeekUiApplicationWindow* self,
                                                       GFile* out_file)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (out_file != NULL);
	if (g_file_has_uri_scheme (out_file, "file")) {
		GFile* parent = NULL;
		GFile* _tmp0_;
		gchar* new_folder = NULL;
		GFile* _tmp1_;
		gchar* _tmp2_;
		gchar* default_folder = NULL;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		_tmp0_ = g_file_get_parent (out_file);
		parent = _tmp0_;
		_tmp1_ = parent;
		_tmp2_ = g_file_get_path (_tmp1_);
		new_folder = _tmp2_;
		_tmp3_ = peek_desktop_integration_get_video_folder ();
		default_folder = _tmp3_;
		_tmp4_ = new_folder;
		_tmp5_ = default_folder;
		if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
			const gchar* _tmp6_;
			_tmp6_ = new_folder;
			peek_ui_application_window_set_save_folder (self, _tmp6_);
		}
		_g_free0 (default_folder);
		_g_free0 (new_folder);
		_g_object_unref0 (parent);
	}
}

static void
peek_ui_application_window_load_geometry (PeekUiApplicationWindow* self)
{
	GVariant* geom = NULL;
	GSettings* _tmp0_;
	GVariant* _tmp1_;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->settings;
	_tmp1_ = g_settings_get_value (_tmp0_, "persist-window-geometry");
	geom = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	_tmp2_ = geom;
	_tmp3_ = g_variant_get_child_value (_tmp2_, (gsize) 0);
	_tmp4_ = _tmp3_;
	x = (gint) g_variant_get_int32 (_tmp4_);
	_g_variant_unref0 (_tmp4_);
	_tmp5_ = geom;
	_tmp6_ = g_variant_get_child_value (_tmp5_, (gsize) 1);
	_tmp7_ = _tmp6_;
	y = (gint) g_variant_get_int32 (_tmp7_);
	_g_variant_unref0 (_tmp7_);
	_tmp8_ = geom;
	_tmp9_ = g_variant_get_child_value (_tmp8_, (gsize) 2);
	_tmp10_ = _tmp9_;
	w = (gint) g_variant_get_int32 (_tmp10_);
	_g_variant_unref0 (_tmp10_);
	_tmp11_ = geom;
	_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) 3);
	_tmp13_ = _tmp12_;
	h = (gint) g_variant_get_int32 (_tmp13_);
	_g_variant_unref0 (_tmp13_);
	if (w == 0) {
		_tmp14_ = TRUE;
	} else {
		_tmp14_ = h == 0;
	}
	if (_tmp14_) {
		_g_variant_unref0 (geom);
		return;
	}
	if (x >= 0) {
		_tmp15_ = y >= 0;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		gtk_window_move ((GtkWindow*) self, x, y);
	}
	gtk_window_resize ((GtkWindow*) self, w, h);
	_g_variant_unref0 (geom);
}

static void
peek_ui_application_window_save_geometry (PeekUiApplicationWindow* self)
{
	GVariantBuilder* builder = NULL;
	const GVariantType* _tmp0_;
	GVariantBuilder* _tmp1_;
	gint x = 0;
	gint y = 0;
	gint w = 0;
	gint h = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	GSettings* _tmp14_;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	g_return_if_fail (self != NULL);
	_tmp0_ = G_VARIANT_TYPE_TUPLE;
	_tmp1_ = g_variant_builder_new (_tmp0_);
	builder = _tmp1_;
	x = 0;
	y = 0;
	w = 0;
	h = 0;
	gtk_window_get_position ((GtkWindow*) self, &_tmp2_, &_tmp3_);
	x = _tmp2_;
	y = _tmp3_;
	gtk_window_get_size ((GtkWindow*) self, &_tmp4_, &_tmp5_);
	w = _tmp4_;
	h = _tmp5_;
	_tmp6_ = g_variant_new_int32 ((gint32) x);
	g_variant_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	g_variant_builder_add_value (builder, _tmp7_);
	_g_variant_unref0 (_tmp7_);
	_tmp8_ = g_variant_new_int32 ((gint32) y);
	g_variant_ref_sink (_tmp8_);
	_tmp9_ = _tmp8_;
	g_variant_builder_add_value (builder, _tmp9_);
	_g_variant_unref0 (_tmp9_);
	_tmp10_ = g_variant_new_int32 ((gint32) w);
	g_variant_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	g_variant_builder_add_value (builder, _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = g_variant_new_int32 ((gint32) h);
	g_variant_ref_sink (_tmp12_);
	_tmp13_ = _tmp12_;
	g_variant_builder_add_value (builder, _tmp13_);
	_g_variant_unref0 (_tmp13_);
	_tmp14_ = self->priv->settings;
	_tmp15_ = g_variant_builder_end (builder);
	g_variant_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	g_settings_set_value (_tmp14_, "persist-window-geometry", _tmp16_);
	_g_variant_unref0 (_tmp16_);
	_g_variant_builder_unref0 (builder);
}

static gint
peek_ui_application_window_get_window_width (PeekUiApplicationWindow* self)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	w = _tmp0_;
	h = _tmp1_;
	result = w;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
peek_ui_application_window_set_close_button_position (PeekUiApplicationWindow* self)
{
	GtkSettings* settings = NULL;
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	gchar* _tmp2_ = NULL;
	GtkSettings* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* decoration_layout = NULL;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	settings = _tmp1_;
	_tmp3_ = settings;
	g_object_get (_tmp3_, "gtk-decoration-layout", &_tmp4_, NULL);
	_tmp5_ = _tmp4_;
	_tmp2_ = _tmp5_;
	if (_tmp2_ == NULL) {
		gchar* _tmp6_;
		_tmp6_ = g_strdup ("");
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp6_;
	}
	_tmp7_ = _tmp2_;
	_tmp2_ = NULL;
	decoration_layout = _tmp7_;
	_tmp8_ = decoration_layout;
	g_debug ("application-window.vala:666: Decoration layout: %s", _tmp8_);
	_tmp9_ = decoration_layout;
	if (string_contains (_tmp9_, ":")) {
		gchar** decoration = NULL;
		const gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint decoration_length1;
		gint _decoration_size_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		const gchar* _tmp14_;
		_tmp10_ = decoration_layout;
		_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, ":", 2);
		decoration = _tmp12_;
		decoration_length1 = _vala_array_length (_tmp11_);
		_decoration_size_ = decoration_length1;
		_tmp13_ = decoration;
		_tmp13__length1 = decoration_length1;
		_tmp14_ = _tmp13_[0];
		if (string_contains (_tmp14_, "close")) {
			peek_ui_application_window_move_close_button_left (self);
		}
		decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
	}
	_g_free0 (decoration_layout);
	_g_free0 (_tmp2_);
	_g_object_unref0 (settings);
}

static void
peek_ui_application_window_move_close_button_left (PeekUiApplicationWindow* self)
{
	gchar** decoration = NULL;
	GtkHeaderBar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint decoration_length1;
	gint _decoration_size_;
	gboolean _tmp5_ = FALSE;
	gchar** _tmp6_;
	gint _tmp6__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->headerbar;
	_tmp1_ = gtk_header_bar_get_decoration_layout (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ":", 2);
	decoration = _tmp4_;
	decoration_length1 = _vala_array_length (_tmp3_);
	_decoration_size_ = decoration_length1;
	_tmp6_ = decoration;
	_tmp6__length1 = decoration_length1;
	if (_tmp6__length1 == 2) {
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
		_tmp7_ = decoration;
		_tmp7__length1 = decoration_length1;
		_tmp8_ = _tmp7_[1];
		_tmp5_ = string_contains (_tmp8_, "close");
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		GtkHeaderBar* _tmp9_;
		gchar** _tmp10_;
		gint _tmp10__length1;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gint _tmp14__length1;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		_tmp9_ = self->priv->headerbar;
		_tmp10_ = decoration;
		_tmp10__length1 = decoration_length1;
		_tmp11_ = _tmp10_[1];
		_tmp12_ = g_strconcat (_tmp11_, ":", NULL);
		_tmp13_ = _tmp12_;
		_tmp14_ = decoration;
		_tmp14__length1 = decoration_length1;
		_tmp15_ = _tmp14_[0];
		_tmp16_ = g_strconcat (_tmp13_, _tmp15_, NULL);
		_tmp17_ = _tmp16_;
		gtk_header_bar_set_decoration_layout (_tmp9_, _tmp17_);
		_g_free0 (_tmp17_);
		_g_free0 (_tmp13_);
	}
	decoration = (_vala_array_free (decoration, decoration_length1, (GDestroyNotify) g_free), NULL);
}

PeekRecordingScreenRecorder*
peek_ui_application_window_get_recorder (PeekUiApplicationWindow* self)
{
	PeekRecordingScreenRecorder* result;
	PeekRecordingScreenRecorder* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_recorder;
	result = _tmp0_;
	return result;
}

void
peek_ui_application_window_set_recorder (PeekUiApplicationWindow* self,
                                         PeekRecordingScreenRecorder* value)
{
	g_return_if_fail (self != NULL);
	if (peek_ui_application_window_get_recorder (self) != value) {
		PeekRecordingScreenRecorder* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_recorder);
		self->priv->_recorder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY]);
	}
}

gboolean
peek_ui_application_window_get_open_file_manager (PeekUiApplicationWindow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_open_file_manager;
	return result;
}

void
peek_ui_application_window_set_open_file_manager (PeekUiApplicationWindow* self,
                                                  gboolean value)
{
	g_return_if_fail (self != NULL);
	if (peek_ui_application_window_get_open_file_manager (self) != value) {
		self->priv->_open_file_manager = value;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY]);
	}
}

gint
peek_ui_application_window_get_size_indicator_delay (PeekUiApplicationWindow* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_size_indicator_delay;
	return result;
}

void
peek_ui_application_window_set_size_indicator_delay (PeekUiApplicationWindow* self,
                                                     gint value)
{
	g_return_if_fail (self != NULL);
	if (peek_ui_application_window_get_size_indicator_delay (self) != value) {
		self->priv->_size_indicator_delay = value;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY]);
	}
}

gint
peek_ui_application_window_get_recording_start_delay (PeekUiApplicationWindow* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_recording_start_delay;
	return result;
}

void
peek_ui_application_window_set_recording_start_delay (PeekUiApplicationWindow* self,
                                                      gint value)
{
	g_return_if_fail (self != NULL);
	if (peek_ui_application_window_get_recording_start_delay (self) != value) {
		self->priv->_recording_start_delay = value;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY]);
	}
}

const gchar*
peek_ui_application_window_get_default_file_name_format (PeekUiApplicationWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_default_file_name_format;
	result = _tmp0_;
	return result;
}

void
peek_ui_application_window_set_default_file_name_format (PeekUiApplicationWindow* self,
                                                         const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, peek_ui_application_window_get_default_file_name_format (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_default_file_name_format);
		self->priv->_default_file_name_format = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY]);
	}
}

const gchar*
peek_ui_application_window_get_save_folder (PeekUiApplicationWindow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_save_folder;
	result = _tmp0_;
	return result;
}

void
peek_ui_application_window_set_save_folder (PeekUiApplicationWindow* self,
                                            const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, peek_ui_application_window_get_save_folder (self)) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_save_folder);
		self->priv->_save_folder = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY]);
	}
}

static void
peek_ui_application_window_class_init (PeekUiApplicationWindowClass * klass,
                                       gpointer klass_data)
{
	peek_ui_application_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PeekUiApplicationWindow_private_offset);
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) peek_ui_application_window_real_configure_event;
	((GtkWidgetClass *) klass)->delete_event = (gboolean (*) (GtkWidget*, GdkEventAny*)) peek_ui_application_window_real_delete_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_peek_ui_application_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_peek_ui_application_window_set_property;
	G_OBJECT_CLASS (klass)->finalize = peek_ui_application_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY] = g_param_spec_object ("recorder", "recorder", "recorder", PEEK_RECORDING_TYPE_SCREEN_RECORDER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY] = g_param_spec_boolean ("open-file-manager", "open-file-manager", "open-file-manager", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY] = g_param_spec_int ("size-indicator-delay", "size-indicator-delay", "size-indicator-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY] = g_param_spec_int ("recording-start-delay", "recording-start-delay", "recording-start-delay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY] = g_param_spec_string ("default-file-name-format", "default-file-name-format", "default-file-name-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY, peek_ui_application_window_properties[PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY] = g_param_spec_string ("save-folder", "save-folder", "save-folder", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/com/uploadedlobster/peek/application-window.ui");
	peek_ui_application_window_signals[PEEK_UI_APPLICATION_WINDOW_RECORDING_FINISHED_SIGNAL] = g_signal_new ("recording-finished", PEEK_UI_TYPE_APPLICATION_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, headerbar));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "recording_view", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, recording_view));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "record_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, record_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stop_button", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, stop_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "size_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, size_indicator));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delay_indicator", FALSE, PeekUiApplicationWindow_private_offset + G_STRUCT_OFFSET (PeekUiApplicationWindowPrivate, delay_indicator));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_window_screen_changed", G_CALLBACK(_peek_ui_application_window_on_window_screen_changed_gtk_widget_screen_changed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_draw", G_CALLBACK(_peek_ui_application_window_on_recording_view_draw_gtk_widget_draw));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_recording_view_size_allocate", G_CALLBACK(_peek_ui_application_window_on_recording_view_size_allocate_gtk_widget_size_allocate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_record_button_clicked", G_CALLBACK(_peek_ui_application_window_on_record_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_stop_button_clicked", G_CALLBACK(_peek_ui_application_window_on_stop_button_clicked_gtk_button_clicked));
}

static void
peek_ui_application_window_instance_init (PeekUiApplicationWindow * self,
                                          gpointer klass)
{
	self->priv = peek_ui_application_window_get_instance_private (self);
	self->priv->size_indicator_timeout = (guint) 0;
	self->priv->delay_indicator_timeout = (guint) 0;
	self->priv->screen_supports_alpha = TRUE;
	self->priv->is_recording = FALSE;
	self->priv->is_postprocessing = FALSE;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
peek_ui_application_window_finalize (GObject * obj)
{
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	_g_object_unref0 (self->priv->_recorder);
	_g_free0 (self->priv->_default_file_name_format);
	_g_free0 (self->priv->_save_folder);
	_g_object_unref0 (self->priv->headerbar);
	_g_object_unref0 (self->priv->recording_view);
	_g_object_unref0 (self->priv->record_button);
	_g_object_unref0 (self->priv->stop_button);
	_g_object_unref0 (self->priv->size_indicator);
	_g_object_unref0 (self->priv->delay_indicator);
	_g_object_unref0 (self->priv->in_file);
	_g_object_unref0 (self->priv->out_file);
	peek_recording_recording_area_destroy (&self->priv->active_recording_area);
	_g_free0 (self->priv->stop_button_label);
	_g_object_unref0 (self->priv->settings);
	G_OBJECT_CLASS (peek_ui_application_window_parent_class)->finalize (obj);
}

GType
peek_ui_application_window_get_type (void)
{
	static volatile gsize peek_ui_application_window_type_id__volatile = 0;
	if (g_once_init_enter (&peek_ui_application_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PeekUiApplicationWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_ui_application_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUiApplicationWindow), 0, (GInstanceInitFunc) peek_ui_application_window_instance_init, NULL };
		GType peek_ui_application_window_type_id;
		peek_ui_application_window_type_id = g_type_register_static (gtk_application_window_get_type (), "PeekUiApplicationWindow", &g_define_type_info, 0);
		PeekUiApplicationWindow_private_offset = g_type_add_instance_private (peek_ui_application_window_type_id, sizeof (PeekUiApplicationWindowPrivate));
		g_once_init_leave (&peek_ui_application_window_type_id__volatile, peek_ui_application_window_type_id);
	}
	return peek_ui_application_window_type_id__volatile;
}

static void
_vala_peek_ui_application_window_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	switch (property_id) {
		case PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY:
		g_value_set_object (value, peek_ui_application_window_get_recorder (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY:
		g_value_set_boolean (value, peek_ui_application_window_get_open_file_manager (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY:
		g_value_set_int (value, peek_ui_application_window_get_size_indicator_delay (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY:
		g_value_set_int (value, peek_ui_application_window_get_recording_start_delay (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY:
		g_value_set_string (value, peek_ui_application_window_get_default_file_name_format (self));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY:
		g_value_set_string (value, peek_ui_application_window_get_save_folder (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_peek_ui_application_window_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	PeekUiApplicationWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PEEK_UI_TYPE_APPLICATION_WINDOW, PeekUiApplicationWindow);
	switch (property_id) {
		case PEEK_UI_APPLICATION_WINDOW_RECORDER_PROPERTY:
		peek_ui_application_window_set_recorder (self, g_value_get_object (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_OPEN_FILE_MANAGER_PROPERTY:
		peek_ui_application_window_set_open_file_manager (self, g_value_get_boolean (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SIZE_INDICATOR_DELAY_PROPERTY:
		peek_ui_application_window_set_size_indicator_delay (self, g_value_get_int (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_RECORDING_START_DELAY_PROPERTY:
		peek_ui_application_window_set_recording_start_delay (self, g_value_get_int (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_DEFAULT_FILE_NAME_FORMAT_PROPERTY:
		peek_ui_application_window_set_default_file_name_format (self, g_value_get_string (value));
		break;
		case PEEK_UI_APPLICATION_WINDOW_SAVE_FOLDER_PROPERTY:
		peek_ui_application_window_set_save_folder (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

