/* utils.c generated by valac 0.46.6, the Vala compiler
 * generated from utils.vala, do not modify */

/*
Peek Copyright (c) 2015-2017 by Philipp Wolfer <ph.wolfer@gmail.com>

This file is part of Peek.

This software is licensed under the GNU General Public License
(version 3 or later). See the LICENSE file in this distribution.
*/

#include "application.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <unistd.h>
#include <gobject/gvaluecollector.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PeekParamSpecUtils PeekParamSpecUtils;

struct _PeekParamSpecUtils {
	GParamSpec parent_instance;
};

static gpointer peek_utils_parent_class = NULL;

#define PEEK_OUTPUT_FORMAT_WEBM "webm"
#define PEEK_OUTPUT_FORMAT_MP4 "mp4"
#define PEEK_OUTPUT_FORMAT_GIF "gif"
static void peek_utils_finalize (PeekUtils * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

gchar*
peek_utils_get_temp_dir (void)
{
	gchar* cache_dir_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* cache_dir = NULL;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp12_;
	gchar* _tmp13_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "peek", NULL);
	cache_dir_path = _tmp1_;
	_tmp2_ = cache_dir_path;
	_tmp3_ = g_file_new_for_path (_tmp2_);
	cache_dir = _tmp3_;
	{
		GFile* _tmp4_;
		_tmp4_ = cache_dir;
		g_file_make_directory_with_parents (_tmp4_, NULL, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch8_g_error;
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp5_ = e;
		if (g_error_matches (_tmp5_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
			const gchar* _tmp6_;
			_tmp6_ = cache_dir_path;
			g_debug ("utils.vala:23: Cache directory does already exist %s\n", _tmp6_);
		} else {
			FILE* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp7_ = stderr;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			fprintf (_tmp7_, "Error: %s\n", _tmp9_);
			_tmp10_ = g_get_tmp_dir ();
			_tmp11_ = g_strdup (_tmp10_);
			result = _tmp11_;
			_g_error_free0 (e);
			_g_object_unref0 (cache_dir);
			_g_free0 (cache_dir_path);
			return result;
		}
		_g_error_free0 (e);
	}
	__finally8:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (cache_dir);
		_g_free0 (cache_dir_path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp12_ = cache_dir;
	_tmp13_ = g_file_get_path (_tmp12_);
	result = _tmp13_;
	_g_object_unref0 (cache_dir);
	_g_free0 (cache_dir_path);
	return result;
}

gchar*
peek_utils_create_temp_file (const gchar* extension,
                             GError** error)
{
	gchar* temp_dir = NULL;
	gchar* _tmp0_;
	gchar* file_name = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint fd = 0;
	gchar* result = NULL;
	g_return_val_if_fail (extension != NULL, NULL);
	_tmp0_ = peek_utils_get_temp_dir ();
	temp_dir = _tmp0_;
	_tmp1_ = g_strconcat ("peekXXXXXX.", extension, NULL);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_filename (temp_dir, _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	file_name = _tmp4_;
	fd = g_mkstemp (file_name);
	close (fd);
	g_debug ("utils.vala:38: Temp file: %s\n", file_name);
	result = file_name;
	_g_free0 (temp_dir);
	return result;
}

gboolean
peek_utils_is_exit_status_success (gint status)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	{
		gboolean _tmp0_ = FALSE;
		_tmp0_ = g_spawn_check_exit_status (status, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch9_g_error;
		}
		if (_tmp0_) {
			result = TRUE;
			return result;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		FILE* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = stderr;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		fprintf (_tmp1_, "Error: %s\n", _tmp3_);
		_g_error_free0 (e);
	}
	__finally9:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp4_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
	result = FALSE;
	return result;
}

gboolean
peek_utils_check_for_executable (const gchar* executable)
{
	gchar** args = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint args_length1;
	gint _args_size_;
	gint status = 0;
	gchar* output = NULL;
	gchar* errorout = NULL;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (executable != NULL, FALSE);
	_tmp0_ = g_strdup ("which");
	_tmp1_ = g_strdup (executable);
	_tmp2_ = g_new0 (gchar*, 2 + 1);
	_tmp2_[0] = _tmp0_;
	_tmp2_[1] = _tmp1_;
	args = _tmp2_;
	args_length1 = 2;
	_args_size_ = args_length1;
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		g_spawn_sync (NULL, args, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp3_, &_tmp4_, &_tmp5_, &_inner_error0_);
		_g_free0 (output);
		output = _tmp3_;
		_g_free0 (errorout);
		errorout = _tmp4_;
		status = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp6_ = FALSE;
			if (_inner_error0_->domain == G_SPAWN_ERROR) {
				goto __catch10_g_spawn_error;
			}
			_g_free0 (errorout);
			_g_free0 (output);
			args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp6_;
		}
		g_debug ("utils.vala:68: Looking for executable %s (%i): %s%s", executable, status, output, errorout);
		result = peek_utils_is_exit_status_success (status);
		_g_free0 (errorout);
		_g_free0 (output);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	goto __finally10;
	__catch10_g_spawn_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_debug ("utils.vala:72: Error: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally10:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp9_ = FALSE;
		_g_free0 (errorout);
		_g_free0 (output);
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp9_;
	}
	result = FALSE;
	_g_free0 (errorout);
	_g_free0 (output);
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

gchar*
peek_utils_get_file_extension_for_format (const gchar* output_format)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	gchar* result = NULL;
	g_return_val_if_fail (output_format != NULL, NULL);
	_tmp0_ = output_format;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == g_quark_from_string (PEEK_OUTPUT_FORMAT_WEBM)) {
		switch (0) {
			default:
			{
				gchar* _tmp3_;
				_tmp3_ = g_strdup ("webm");
				result = _tmp3_;
				return result;
			}
		}
	} else if (_tmp2_ == g_quark_from_string (PEEK_OUTPUT_FORMAT_MP4)) {
		switch (0) {
			default:
			{
				gchar* _tmp4_;
				_tmp4_ = g_strdup ("mp4");
				result = _tmp4_;
				return result;
			}
		}
	} else if (_tmp2_ == g_quark_from_string (PEEK_OUTPUT_FORMAT_GIF)) {
		switch (0) {
			default:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup ("gif");
				result = _tmp5_;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup ("");
				result = _tmp6_;
				return result;
			}
		}
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
	if (_vala_c != ((gunichar) 0)) {
		gchar* _tmp0_;
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
		*index = (gint) (_tmp0_ - ((gchar*) self));
		result = TRUE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	} else {
		result = FALSE;
		if (c) {
			*c = _vala_c;
		}
		return result;
	}
	if (c) {
		*c = _vala_c;
	}
}

gboolean
peek_utils_string_is_empty (const gchar* str)
{
	gunichar c = 0U;
	gboolean result = FALSE;
	if (str == NULL) {
		result = TRUE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gunichar _tmp1_ = 0U;
				gboolean _tmp2_;
				gboolean _tmp3_ = FALSE;
				if (!_tmp0_) {
				}
				_tmp0_ = FALSE;
				_tmp2_ = string_get_next_char (str, &i, &_tmp1_);
				c = _tmp1_;
				if (!_tmp2_) {
					break;
				}
				if (!g_unichar_isspace (c)) {
					_tmp3_ = !g_unichar_iscntrl (c);
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}

gint
peek_utils_make_even (gint i)
{
	gint result = 0;
	result = (i / 2) * 2;
	return result;
}

PeekUtils*
peek_utils_construct (GType object_type)
{
	PeekUtils* self = NULL;
	self = (PeekUtils*) g_type_create_instance (object_type);
	return self;
}

PeekUtils*
peek_utils_new (void)
{
	return peek_utils_construct (PEEK_TYPE_UTILS);
}

static void
peek_value_utils_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
peek_value_utils_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		peek_utils_unref (value->data[0].v_pointer);
	}
}

static void
peek_value_utils_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = peek_utils_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
peek_value_utils_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
peek_value_utils_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		PeekUtils * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = peek_utils_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
peek_value_utils_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	PeekUtils ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = peek_utils_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
peek_param_spec_utils (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	PeekParamSpecUtils* spec;
	g_return_val_if_fail (g_type_is_a (object_type, PEEK_TYPE_UTILS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
peek_value_get_utils (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS), NULL);
	return value->data[0].v_pointer;
}

void
peek_value_set_utils (GValue* value,
                      gpointer v_object)
{
	PeekUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		peek_utils_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		peek_utils_unref (old);
	}
}

void
peek_value_take_utils (GValue* value,
                       gpointer v_object)
{
	PeekUtils * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PEEK_TYPE_UTILS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PEEK_TYPE_UTILS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		peek_utils_unref (old);
	}
}

static void
peek_utils_class_init (PeekUtilsClass * klass,
                       gpointer klass_data)
{
	peek_utils_parent_class = g_type_class_peek_parent (klass);
	((PeekUtilsClass *) klass)->finalize = peek_utils_finalize;
}

static void
peek_utils_instance_init (PeekUtils * self,
                          gpointer klass)
{
	self->ref_count = 1;
}

static void
peek_utils_finalize (PeekUtils * obj)
{
	PeekUtils * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PEEK_TYPE_UTILS, PeekUtils);
	g_signal_handlers_destroy (self);
}

GType
peek_utils_get_type (void)
{
	static volatile gsize peek_utils_type_id__volatile = 0;
	if (g_once_init_enter (&peek_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { peek_value_utils_init, peek_value_utils_free_value, peek_value_utils_copy_value, peek_value_utils_peek_pointer, "p", peek_value_utils_collect_value, "p", peek_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PeekUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) peek_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PeekUtils), 0, (GInstanceInitFunc) peek_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType peek_utils_type_id;
		peek_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PeekUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&peek_utils_type_id__volatile, peek_utils_type_id);
	}
	return peek_utils_type_id__volatile;
}

gpointer
peek_utils_ref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
peek_utils_unref (gpointer instance)
{
	PeekUtils * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		PEEK_UTILS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

